#include "lcd_19264.h"
#include "delay.h"
#include "ascii_5x8.h"
/*
#define LCD_CSA_H()	(GPIO_WriteHigh(LCD_CS_PORT, LCD_CSA_PIN))
//#define LCD_CSA_H()     (LCD_CS_PORT->ODR |= (1<<LCD_CSA_PIN))
#define LCD_CSA_L()	(GPIO_WriteLow(LCD_CS_PORT, LCD_CSA_PIN))
#define LCD_CSB_H()	(GPIO_WriteHigh(LCD_CS_PORT, LCD_CSB_PIN))
#define LCD_CSB_L()	(GPIO_WriteLow(LCD_CS_PORT, LCD_CSB_PIN))
#define LCD_E_H()	(GPIO_WriteHigh(LCD_CONTROL_PORT, LCD_E_PIN))
#define LCD_E_L()	(GPIO_WriteLow(LCD_CONTROL_PORT, LCD_E_PIN))
#define LCD_RS_H()	(GPIO_WriteHigh(LCD_CONTROL_PORT, LCD_RS_PIN))
#define LCD_RS_L()	(GPIO_WriteLow(LCD_CONTROL_PORT, LCD_RS_PIN))
#define LCD_RW_H()	(GPIO_WriteHigh(LCD_CONTROL_PORT, LCD_RW_PIN))
#define LCD_RW_L()	(GPIO_WriteLow(LCD_CONTROL_PORT, LCD_RW_PIN))
*/

#define LCD_CSA_H()	(PG_ODR|=0X01)
#define LCD_CSA_L()	(PG_ODR&=~0x01)
#define LCD_CSB_H()	(PG_ODR|=0X02)
#define LCD_CSB_L()	(PG_ODR&=~0X02)
#define LCD_E_H()	(PA_ODR|=(1<<4))
#define LCD_E_L()	(PA_ODR&=~(1<<4))
#define LCD_RS_H()	(PA_ODR|=(1<<6))
#define LCD_RS_L()	(PA_ODR&=~(1<<6))
#define LCD_RW_H()	(PA_ODR|=(1<<5))
#define LCD_RW_L()	(PA_ODR&=~(1<<5))

#define LCD_DATA_INPUT_MODE()   (GPIO_Init(LCD_DATA_PORT, LCD_DATA_PIN, GPIO_MODE_IN_FL_NO_IT))
#define LCD_DATA_OUTPUT_MODE()  (GPIO_Init(LCD_DATA_PORT, LCD_DATA_PIN, GPIO_MODE_OUT_PP_HIGH_FAST))
#define LCD_SET_DATA(x)	        (PB_ODR = x&0xf0, PC_ODR=(x<<4), PE_ODR=(x&0x01))
#define LCD_READ_DATA()	        (GPIO_ReadInputData(LCD_DATA_PORT))

static u8 dirty;
@near volatile static u8 DisplayBuffer[8][192];

void LCD_WriteCommand(u8 cmd, u8 ChipSel)
{
	LCD_E_L();
	LCD_RW_L();

	if( ChipSel == LCD_LEFT )
	{
        LCD_CSB_L();
		LCD_CSA_L();
	}
	else if( ChipSel == LCD_MID )
	{
        // CSB_CSA
		LCD_CSB_L();
        LCD_CSA_H();
	}
	else
	{
        LCD_CSB_H();
		LCD_CSA_L();
	}

	LCD_RS_L();	// Command signal
	delay_us(3);
	LCD_E_H();

	LCD_SET_DATA(cmd);
	//GPIO_Write(LCD_DATA_PORT, cmd);
    //GPIO_Write(LCD_DATA2_PORT, cmd<<5);
    delay_us(3);

	LCD_E_L();
	LCD_RW_H();
    LCD_E_H();
	LCD_CSB_H();
	LCD_CSA_H();


}

void LCD_WriteData(u8 Data, u8 ChipSel)
{
	LCD_E_L();	
	LCD_RW_L();
    if( ChipSel == LCD_LEFT )
	{
        LCD_CSB_L();
		LCD_CSA_L();
	}
	else if( ChipSel == LCD_MID )
	{
        // CSB_CSA
		LCD_CSB_L();
        LCD_CSA_H();
	}
	else
	{
        LCD_CSB_H();
		LCD_CSA_L();
	}
	LCD_RS_H();	// Data signal
	delay_us(3);
	LCD_E_H();

	LCD_SET_DATA(Data);
    //GPIO_Write(LCD_DATA_PORT, Data);
   // GPIO_Write(LCD_DATA2_PORT, Data<<5);
    
    delay_us(3);

	LCD_E_L();
	LCD_RW_H();
    LCD_E_H();
	LCD_CSB_H();
	LCD_CSA_H();

}

u8 LCD_ReadData(void)
{
	u8 rData;

	LCD_E_L();
	LCD_RW_H();
    
    LCD_CSA_L();
    LCD_CSB_L();
	
	LCD_RS_H();

	LCD_E_H();
	delay_us(1);
	
	LCD_DATA_INPUT_MODE();
	rData = LCD_READ_DATA();
	LCD_DATA_OUTPUT_MODE();

	LCD_RW_L();
	LCD_E_H();
	LCD_CSA_H();
	LCD_CSB_H();

	return rData;

}

u8 LCD_ReadCommand(void)
{
	u8 rData;

	LCD_E_L();
	LCD_RW_H();

	LCD_CSA_L();
	LCD_CSB_L();
	
	LCD_RS_L();

	LCD_E_H();
	delay_us(1);

	LCD_DATA_INPUT_MODE();
	rData = LCD_READ_DATA();
	LCD_DATA_OUTPUT_MODE();

	LCD_RW_L();
	LCD_E_H();
	LCD_CSA_H();
	LCD_CSB_H();

	return rData;

}

void LCD_Init(void)
{
    int i;
    @near u8 *p;
    p = (u8*)DisplayBuffer;
/*
    GPIO_Init(LCD_DATA_PORT, LCD_DATA_PIN, GPIO_MODE_OUT_PP_HIGH_FAST);
    GPIO_Init(LCD_DATA2_PORT, LCD_DATA2_PIN, GPIO_MODE_OUT_PP_HIGH_FAST);
	GPIO_Init(LCD_CONTROL_PORT, (LCD_E_PIN|LCD_RS_PIN|LCD_RW_PIN), GPIO_MODE_OUT_PP_HIGH_FAST);
	GPIO_Init(LCD_CS_PORT, (LCD_CSA_PIN|LCD_CSB_PIN), GPIO_MODE_OUT_PP_HIGH_FAST);
    GPIO_Init(LCD_RES_PORT, LCD_RES_PIN, GPIO_MODE_OUT_PP_HIGH_FAST);
*/

    PB_DDR = 0xf0;
    PB_CR1 = 0xf0;
    PB_CR2 = 0xf0;
    
    PC_DDR = 0xe0;                              // pc5\6\7
    PC_CR1 = 0xe0;
    PC_CR2 = 0xe0;
    
    PA_DDR |= (1<<4)|(1<<5)|(1<<6);              /* Output.                   */
    PA_CR1 |= (1<<4)|(1<<5)|(1<<6);              /* PushPull.                 */
    PA_CR2 |= (1<<4)|(1<<5)|(1<<6);              /* Output speed up to 10MHz. */
    
    PG_DDR |= 0X03;
    PG_CR1 |= 0X03;
    PG_CR2 |= 0X03;
    
    PE_DDR |= 0X01;
    PE_CR1 |= 0X01;
    PE_CR2 |= 0X01;
    PE_ODR |= 0X01;
    
    for(i = 0; i < 192*8; ++i, ++p)
        *p = 0;
    LCD_WriteCommand(LCD_DISPLAY_ON, LCD_LEFT);
    LCD_WriteCommand(LCD_DISPLAY_ON, LCD_MID);
    LCD_WriteCommand(LCD_DISPLAY_ON, LCD_RIGHT);
    LCD_WriteCommand(LCD_START_LINE+0, LCD_LEFT);
    
}

void LCD_BufferDrawPixel(u8 x, u8 y, DrawMode mode)
{
	char DX = (y >> 3);                 // 计算出属于哪个字节 
	char BX = (y & 0x07);               // 计算出属于字节哪一位 
    u8 temp = (1<<BX);

	switch(mode){
		case LCD_CLEAR:
			DisplayBuffer[DX][x] &= ~(1<<BX);
			break;
		case LCD_NOT:
			DisplayBuffer[DX][x] ^= (1<<BX);
			break;
		case LCD_SET:
			DisplayBuffer[DX][x] |= (1<<BX);
			break;
		default:
			break;
	}
    dirty = 1;
/*
    u8 chip;
    if( x < 64)
        chip = LCD_LEFT;
    else if( x < 128 )
        chip = LCD_MID;
    else
        chip = LCD_RIGHT;
        
    LCD_WriteCommand( LCD_XPAGE_BASE+DX, chip);
    LCD_WriteCommand( LCD_YADDR_BASE+(x%64), chip);
    LCD_WriteData(temp, chip);
*/    
}

// (x,y) Start Point
static void LCD_BufferDrawXLine(u8 x, u8 y, u8 len, DrawMode mode)
{
	u8 DX = (y >> 3);
	u8 BX = (y & 0x07);
	u8 mask = (1 << BX);
	u8 nmask = ~mask;
	u8 i;
	for( i = 0; i < len; ++i,++x)
		switch(mode){
		case LCD_CLEAR:
			DisplayBuffer[DX][x] &= nmask;
			break;
		case LCD_NOT:
			DisplayBuffer[DX][x] ^= mask;
			break;
		case LCD_SET:
			DisplayBuffer[DX][x] |= mask;
			break;
		default:
			break;
	}
	
}

// (x,y) Start Point
void LCD_BufferDrawXDotLine(u8 x, u8 y, u8 len, DrawMode mode)
{
	u8 DX = (y >> 3);
	u8 BX = (y & 0x07);
	u8 mask = (1 << BX);
	u8 nmask = ~mask;
	u8 i;
	for( i = 0; i < len; i+=2,x+=2)
		switch(mode){
		case LCD_CLEAR:
			DisplayBuffer[DX][x] &= nmask;
			break;
		case LCD_NOT:
			DisplayBuffer[DX][x] ^= mask;
			break;
		case LCD_SET:
			DisplayBuffer[DX][x] |= mask;
			break;
		default:
			break;
	}
	
}

// (x,y) Start Point
static void LCD_BufferDrawYLine(u8 x, u8 y, u8 len, DrawMode mode)
{
	u8 DX = (y >> 3);
	u8 BX = (y & 0x07);
	switch(mode){
		case LCD_CLEAR:
			DisplayBuffer[DX][x] &= ~(0xff << BX);
			break;
		case LCD_NOT:
			DisplayBuffer[DX][x] ^= (0xff << BX);
			break;
		case LCD_SET:
			DisplayBuffer[DX][x] |= (0xff << BX);
			break;
		default:
			break;
	}
	DX++;
	len -= (8-BX);
	while( len >= 8 )
	{
		switch(mode){
			case LCD_CLEAR:
				DisplayBuffer[DX][x] &= 0;
				break;
			case LCD_NOT:
				DisplayBuffer[DX][x] ^= 0xff;
				break;
			case LCD_SET:
				DisplayBuffer[DX][x] |= 0xff;
				break;
			default:
				break;
		}
		DX++;
		len -= 8;
	}
	if(len)
	{
		switch(mode){
			case LCD_CLEAR:
				DisplayBuffer[DX][x] &= (0xff << len);
				break;
			case LCD_NOT:
				DisplayBuffer[DX][x] ^= ~(0xff << len);
				break;
			case LCD_SET:
				DisplayBuffer[DX][x] |= ~(0xff << len);
				break;
			default:
				break;
		}
	}
}

void LCD_BufferDrawYDotLine(u8 x, u8 y, u8 len, DrawMode mode)
{
	u8 DX = (y >> 3);
	u8 BX = (y & 0x07);
	switch(mode){
		case LCD_CLEAR:
			DisplayBuffer[DX][x] &= ~(0xff << BX)&0xaa;
			break;
		case LCD_NOT:
			DisplayBuffer[DX][x] ^= (0xff << BX)&0x55;
			break;
		case LCD_SET:
			DisplayBuffer[DX][x] |= (0xff << BX)&0x55;
			break;
		default:
			break;
	}
	DX++;
	len -= (8-BX);
	while( len >= 8 )
	{
		switch(mode){
			case LCD_CLEAR:
				DisplayBuffer[DX][x] &= 0xaa;
				break;
			case LCD_NOT:
				DisplayBuffer[DX][x] ^= 0x55;
				break;
			case LCD_SET:
				DisplayBuffer[DX][x] |= 0x55;
				break;
			default:
				break;
		}
		DX++;
		len -= 8;
	}
	if(len)
	{
		switch(mode){
			case LCD_CLEAR:
				DisplayBuffer[DX][x] &= (0xff << len)&0xaa;
				break;
			case LCD_NOT:
				DisplayBuffer[DX][x] ^= ~(0xff << len)&0x55;
				break;
			case LCD_SET:
				DisplayBuffer[DX][x] |= ~(0xff << len)&0x55;
				break;
			default:
				break;
		}
	}
}

#define abs(x) ((x>0)?(x):(-(x)))

void LCD_BufferDrawLine(u8 x1, u8 y1, u8 x2, u8 y2, DrawMode mode)
{
	u8 x, y, t;
	int dx, dy, d, incrE, incrNE;
	if( y1 > y2)
	{
		t = x1, x1 = x2, x2 = t;
		t = y1, y1 = y2, y2 = t;
	}
	dx = x2 - x1;
	dy = y2 - y1;
	x = x1, y = y1;
	if( 0 == dx )
	{
			LCD_BufferDrawYLine(x1, y1, dy, mode);
	}
	else if( 0 == dy )
	{
			if( x1 > x2 )
				LCD_BufferDrawXLine(x2, y2, dx, mode);
			else
				LCD_BufferDrawXLine(x1, y1, dx, mode);
	}
	else
	{
		// Bresenham Midpoint Line
		if( abs(dx) > abs(dy) )
		{	
			if( x2 > x1)
			{
				// 0 < k < 1
				d = 2 * dy - dx;
				incrE = 2 * dy;
				incrNE = 2 * (dy - dx);
				while( x < x2 )
				{
					LCD_BufferDrawPixel(x, y, mode);
					x++;
					if( d > 0 )
					{
						y++;
						d += incrNE;
					}
					else
						d += incrE;
				}
				LCD_BufferDrawPixel(x, y, mode);
			}
			else
			{
				// -1 < k < 0
				d = -2 * dy - dx;
				incrE = -2 * dy;
				incrNE = -2 * (dy + dx);
				while( x > x2)
				{
					LCD_BufferDrawPixel(x, y, mode);
					x--;
					if( d < 0 )
					{
						y++;
						d += incrNE;
					}
					else
						d += incrE;
				}
				LCD_BufferDrawPixel(x, y, mode);			
			}
		}
		else
		{	
			if( x2 > x1)
			{
				// k > 1
				d = dy - 2 * dx;
				incrE = -2 * dx;
				incrNE = 2 * (dy - dx);
				while( y < y2 )
				{
					LCD_BufferDrawPixel(x, y, mode);
					y++;
					if( d < 0 )	
					{
						x++;
						d += incrNE;
					}
					else
						d += incrE;
				}
				LCD_BufferDrawPixel(x, y, mode);
			}
			else
			{
				// k < -1
				d = -dy - 2 * dx;
				incrE = -2 * dx;
				incrNE = -2 * (dy + dx);
				while( y < y2 )
				{
					LCD_BufferDrawPixel(x, y, mode);
					y++;
					if( d > 0 )
					{
						x--;
						d += incrNE;
					}
					else
						d += incrE;
				}
				LCD_BufferDrawPixel(x, y, mode);
			}
		}
	}
    dirty = 1;
}

void LCD_BufferToLCD(void)
{
	u8 chip, x, y, i, j;
    
    u8 AddX, AddY;
    
    if( dirty == 0)
        return;
    
    for(chip = 0, j = 0; chip < 3; ++chip, j+=64)
    {
        AddX = LCD_XPAGE_BASE;
        AddY = LCD_YADDR_BASE;
        LCD_WriteCommand(LCD_DISPLAY_ON, chip);
        LCD_WriteCommand(LCD_START_LINE, chip);
        for( x = 0; x < 8; ++x )
        {
            LCD_WriteCommand(AddX, chip);
            LCD_WriteCommand(AddY, chip);
            for( y = 0; y < 64; ++y )
            {
                LCD_WriteData(DisplayBuffer[x][y+j], chip);
            }
            AddX++;
        }
    }
    dirty = 0;
    /*
	for( i = 0; i < 8; ++i )
	{
        LCD_WriteCommand(LCD_DISPLAY_ON, LCD_LEFT);
        LCD_WriteCommand(LCD_START_LINE+0, LCD_LEFT);
		LCD_WriteCommand( LCD_XPAGE_BASE + i, LCD_LEFT );
		LCD_WriteCommand( LCD_YADDR_BASE + 0, LCD_LEFT);
		for( j = 0; j < 64; ++j)
			LCD_WriteData(DisplayBuffer[i][j], LCD_LEFT);
            //LCD_WriteData(0xf0, LCD_LEFT);
         
        LCD_WriteCommand(LCD_DISPLAY_ON, LCD_MID);
        LCD_WriteCommand(LCD_START_LINE+0, LCD_MID);            
        LCD_WriteCommand( LCD_XPAGE_BASE + i, LCD_MID );
		LCD_WriteCommand( LCD_YADDR_BASE + 0, LCD_MID );
        for( ; j < 128; ++j)
            LCD_WriteData(DisplayBuffer[i][j], LCD_MID);
            //LCD_WriteData(0xf0, LCD_MID);
           
        LCD_WriteCommand(LCD_DISPLAY_ON, LCD_RIGHT);
        LCD_WriteCommand(LCD_START_LINE+0, LCD_RIGHT);           
        LCD_WriteCommand( LCD_XPAGE_BASE + i, LCD_RIGHT);
		LCD_WriteCommand( LCD_YADDR_BASE + 0, LCD_RIGHT );
        for( ; j < 192; ++j)
            LCD_WriteData(DisplayBuffer[i][j], LCD_RIGHT);
            //LCD_WriteData(0xf0, LCD_RIGHT);
    }
    */
}

void LCD_Clear(void)
{
	u8 i, j;
	for( i = 0; i < 8; ++i )
	{
        for(j = 0; j < 192; ++j)
            DisplayBuffer[i][j] = 0;
    }
    dirty = 1;
}

//  дıģʽµСеַ  
static void LCD_GoTextXY(u8 x, u8 y)
{ 
    u8 chip;
    u8 tmp = x * 6;
    if(tmp > 192) tmp=0;       // еַΧͻص0  
    if(y > 8) y=0;             // еַΧͻص0  
    if( tmp < 64 )
    {
        chip = LCD_LEFT;
    }
    else if( tmp < 128 )
    {
        chip = LCD_MID;
        tmp -= 64;
    }else
    {
        chip = LCD_RIGHT;
        tmp -= 128;
    }
    LCD_WriteCommand(LCD_XPAGE_BASE+y, chip);
    LCD_WriteCommand(LCD_YADDR_BASE+tmp, chip);
} 
    
// ıģʽx0~31y0~7ÿַ֮һ6X8
void LCD_PutChar5x8(u8 x, u8 y, unsigned char ASCII)
{
    u8 i;  
    u16 No; 
    u8 tmp = x * 6;                // һַռĻ6             
    No = ASCII - 32;               // ģɿո  ʼոASCIIֵ32  
    No = No * 5;                   // ÿַģ5 ֽ 
    
    for(i = 0; i < 5; ++i)         // һַģ5 ֽ,5*8  
    {  
        DisplayBuffer[y][tmp++] = cAscii5x8Bitmap[No++]; 
    }  
    dirty = 1;
}    

void LCD_PutString5x8(u8 x, u8 y, unsigned char *str)
{
    while(*str)
    {
        LCD_PutChar5x8(x++, y, *str++);
    }
}