#ifndef _LCD19264_H
#define _LCD19264_H

#include "stm8s.h"
#include "stm8s207r.h"
// DB7~DB3
#define LCD_DATA_PORT		(GPIOB)
#define LCD_DATA_PIN		(GPIO_PIN_7|GPIO_PIN_6|GPIO_PIN_5|GPIO_PIN_4|GPIO_PIN_3)
// DB2,DB1,DB0
#define LCD_DATA2_PORT      (GPIOC)
#define LCD_DATA2_PIN       (GPIO_PIN_7|GPIO_PIN_6|GPIO_PIN_5)

// E, RS, RW
#define LCD_CONTROL_PORT	(GPIOA)
#define LCD_E_PIN		(GPIO_PIN_4)
#define LCD_RW_PIN		(GPIO_PIN_5)
#define LCD_RS_PIN		(GPIO_PIN_6)
// CSA, CSB
#define LCD_CS_PORT		(GPIOG)
#define LCD_CSA_PIN		(GPIO_PIN_0)
#define LCD_CSB_PIN		(GPIO_PIN_1)

#define LCD_RES_PORT    (GPIOE)
#define LCD_RES_PIN     (GPIO_PIN_0)

#define LCD_LEFT        ((u8)0)
#define LCD_MID         ((u8)1)
#define LCD_RIGHT       ((u8)2)

#define LCD_DISPLAY_ON  ((u8)0x3f)
#define LCD_DISPLAY_OFF ((u8)0x3e)
#define LCD_YADDR_BASE  ((u8)0x40)
#define LCD_XPAGE_BASE  ((u8)0xB8)
#define LCD_START_LINE  ((u8)0xC0)

typedef enum _DrawMode{
	LCD_CLEAR,
	LCD_NOT,
	LCD_SET
}DrawMode;



void LCD_Init(void);
void LCD_WriteCommand(u8 cmd, u8 ChipSel);
void LCD_WriteData(u8 Data, u8 ChipSel);
void LCD_BufferDrawPixel(u8 x, u8 y, DrawMode mode);
void LCD_BufferDrawLine(u8 x1, u8 y1, u8 x2, u8 y2, DrawMode mode);
void LCD_BufferDrawXDotLine(u8 x, u8 y, u8 len, DrawMode mode);
void LCD_BufferDrawYDotLine(u8 x, u8 y, u8 len, DrawMode mode);
void LCD_BufferToLCD(void);
void LCD_PutString5x8(u8 x, u8 y, unsigned char *str);
void LCD_PutChar5x8(u8 x, u8 y, unsigned char ASCII);
#endif
